# Real Bots release 1.0 by Knight
# ./addons/eventscripts/realbots/realbots.py

# >>> To configure this addon please see config.cfg <<<

#################################
#### DO NOT EDIT THIS FILE, #####
####    IF YOU DO, THINGS   #####
####       COULD BREAK      #####
#################################

""" Eventscript Libraries """
import es
import playerlib
import gamethread
import cfglib
#import cmdlib

""" Engine loads """
import os
import random
from configobj import ConfigObj
from string import Template
from shutil import move as move

# psyco, more unstable but a lot faster
import psyco
psyco.full() 

# Set the addon info data
info          = es.AddonInfo()
info.name     = 'Real Bots'
info.version  = '1.1.0a'
info.basename = 'realbots'
info.url      = 'http://addons.eventscripts.com/addons/view/%s'%info.basename
info.author   = 'Freddukes AKA Pro Noob'

# Make Public Variable
es.ServerVar('realbots_version', info.version, info.name + ' Version - Made by ' + info.author).makepublic()

#########################
### OBJECT MANAGEMENT ###
#########################

class LoadError(Exception):
    """ Class to allow a custom raise error """
    pass

class BotManager(object):
    """ An object to manage all of the bots """
    
    templates   = {}
    bots        = {}
    botCount    = 0
    speechPath  = os.path.join( es.getAddonPath(info.basename), "bot_speech.ini")
    if not os.path.isfile(speechPath):
        raise LoadError, "Cannot find bot_speech.ini in ../addons/eventscripts/%s"%info.basename
        es.unload(info.basename)
    sayEvents   = ConfigObj( speechPath )
    
    def __init__(self):
        """ Initialize the BotManager class """
        self.botprofile = str(es.ServerVar('eventscripts_gamedir')).replace('\\','/') + "/botprofile.db"
        self.directory  = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[-1]
        
        if self.directory == "cstrike":
            self.botAdd        = "bot_add"
            self.playerManager = es.getentityindex('cs_player_manager')
            
        elif self.directory == "tf":
            self.botAdd = "bot"
            self.playerManager = es.getentityindex('tf2_player_manager')
            
        elif self.directory == "hl2mp":
            self.botAdd = "bot_add"
            self.playerManager = es.getentityindex('player_manager')
            
        else:
            raise LoadError, "The game %s is not supported" % es.getgame()
            es.unload( info.basename )
            
    def createTemplate(self, templateType, name, skill=None, agression=None, reactionTime=None, difficulty="NORMAL", pitch=90, weaponPreference=None):
        """ 
        Create a template and add it to the template dictionary to write to
        the botprofile.db
        """
        if templateType.lower() == "skill":
            difficulty = difficulty.upper()
            if difficulty not in ("EASY", "NORMAL", "HARD", "EXPERT"):
                difficulty = "NORMAL"
            self.templates[name] = {'Type':'skill', 'Skill':skill, 'Aggression':agression, 'ReactionTime':reactionTime, 'Difficulty':difficulty.upper(), 'VoicePitch':pitch}
        elif templateType.lower() == "weapon":
            if isinstance(weaponPreference, str):
                weaponPrefence = (weaponPreference,)
            self.templates[name] = {'Type':'weapon', 'WeaponPreference': weaponPreference}
            
    def createBot(self, skillTemplate, weaponTemplate, name, skin=1, pitch=90):
        """  """
        if name not in self.bots:
            self.bots[name] = {}
            self.bots[name]['skillTemplate']  = skillTemplate
            self.bots[name]['weaponTemplate'] = weaponTemplate
            self.bots[name]['skin']           = skin
            self.bots[name]['pitch']          = pitch
    
    def deleteBot(self, name):
        """  """
        if name in self.bots:
            del self.bots[name]
            
    def addBot(self, name=None):
        """  """
        if self.botCount < int(rb_botAmount):
            if name is not None:
                if name in map(es.getplayername, filter(es.isbot, es.getUseridList() ) ):
                    name = None
                else:
                    es.server.cmd('bot_add \"%s\"'%name)
            else:
                es.server.cmd('bot_add')
            self.botCount += 1
            if self.botCount == 1:
                if int(rb_ping):
                    gamethread.delayedname(float(rb_pingUpdateDelay), 'botPing', self.updatePing)
        
    def removeBot(self, name=None):
        """  """
        self.updateBotCount()
        if not self.botCount:
            return
        if not name:
            name = es.getplayername(random.choice(filter(es.isbot, es.getUseridList() ) ) )
        if name in map(es.getplayername, filter(es.isbot, es.getUseridList() ) ):
            es.server.queuecmd('kick "%s"' % name)
            self.botCount -= 1
            
            if not self.botCount:
                gamethread.cancelDelayed('botPing')
                gamethread.cancelDelayed('updateBotCount')
        else:
            if not filter(es.isbot, es.getUseridList() ):
                self.botCount = 0
                return
            self.removeBot()
        
    def removeAllBots(self):
        es.server.queuecmd('bot_kick')
        
    def command(self, command, playerlist=[]):
        """  """
        if not playerlist:
            playerlist = filter(lambda x: es.isbot(x) and not es.getplayerprop(x,'CBasePlayer.pl.deadflag'), es.getUseridList() )
        for bot in playerlist:
            es.server.queuecmd(command)
        
    def updatePing(self):
        """  """
        for player in playerlib.getPlayerList('#bot'):
            es.setindexprop(self.playerManager, "CPlayerResource.m_iPing.%03d" % player.get('index'), (random.randint(int(rb_minPing), int(rb_maxPing) ) ) )
        gamethread.delayedname(float(rb_pingUpdateDelay), 'botPing', self.updatePing)
        
    def updateBotCount(self):
        self.botCount = len( filter(es.isbot, es.getUseridList() ) )
        
    def execute(self):
        """  """
        thisFile = open(self.botprofile, 'r')
        tempStr  = ""
        tempStr += """\
//----------------------------------------------------------------------------
// BotProfile_realbots.db
// Author: """ + info.author + """
//
// This database defines bot "personalities". 
// Feel free to edit it and define your own bots.
//


//----------------------------------------------------------------------------

//
// All profiles begin with this data and overwrite their own
//
Default
	Skill = 90
	Aggression = 90
	ReactionTime = 0.1
	Cost = 4
	Difficulty = EXPERT
	VoicePitch = 88
        Skin = 0 
End

//----------------------------------------------------------------------------

//
// These templates inherit from Default and override with their values
// The name of the template defines a type that is used by individual bot profiles
//

//----------------------------------------------------------------------------
// weapon preference templates
//----------------------------------------------------------------------------
"""
        for template in filter(lambda x: self.templates[x]["Type"] == "weapon", self.templates):
            tempStr += 'Template %s\n' % template
            for weaponPreference in self.templates[template]['WeaponPreference']:
                tempStr += '\tWeaponPreference = %s\n' % weaponPreference.lower()
            tempStr += 'End\n\n'
        tempStr += '//----------------------------------------------------------------------------\n'
        tempStr += '// skill templates\n'
        tempStr += '//----------------------------------------------------------------------------\n'
        for template in filter(lambda x: self.templates[x]["Type"] == "skill", self.templates):
            tempStr += 'Template %s\n' % template
            for option in self.templates[template]:
                if option != "Type":
                    tempStr += "\t%s = %s\n" % (option, self.templates[template][option])
            tempStr += 'End\n\n'
        tempStr += """\
//----------------------------------------------------------------------------
//
// These are the individual bot profiles, which inherit first from 
// Default and then the specified Template(s), in order
//

"""
        for bot in self.bots:
            tempStr += '%s+%s "%s"\n' % (self.bots[bot]['skillTemplate'], self.bots[bot]['weaponTemplate'], bot)
            tempStr += '\tSkin = %s\n' % self.bots[bot]['skin']
            tempStr += '\tVoicePitch = %s\n' % self.bots[bot]['pitch']
            tempStr += 'End\n\n'
        tempStr += '//----------------------------------------------------------------------------\n'
        tempStr += '// END OF FILE - Conversion by ' + info.author + '\n'
        tempStr += '//----------------------------------------------------------------------------'
        addBots = True
        currentLines = thisFile.read()
        if currentLines[107:123] == "Michael S. Booth":
            """ This is the default botprofile.db so back it up """
            folderPath = "/".join(os.path.join(self.botprofile.split('/')[:-1]) )
            if not os.path.isdir( folderPath + "/botprofilebackup" ):
                os.mkdir(folderPath + "/botprofilebackup")
            thisFile.close()
            move(self.botprofile, os.path.join( "/".join(self.botprofile.split('/')[:-1]) + "/botprofilebackup/botprofile.db" ) )
        if currentLines != tempStr:
            es.dbgmsg(0, "Botprofile.db Updated!!! In need of a map change")
            thisFile.close()
            thisFile = open(self.botprofile, 'w')
            thisFile.write(tempStr)
            addBots  = False
        thisFile.close()
        return addBots
        
bots = BotManager()

configPath = os.path.join( es.getAddonPath( info.basename), "config.cfg" )
config     = cfglib.AddonCFG(configPath)
config.text("------------------------------------------------------------------------------")
config.text("../addons/eventscripts/" + info.basename + "/config.cfg")
config.text("Real Bots Version %s by %s" % ( info.version, info.author ) )
config.text("------------------------------------------------------------------------------")
config.text("", False)

rb_ping            = config.cvar("rb_ping",             1, "Allow bots to have a random ping value?")
rb_minPing         = config.cvar("rb_minPing",         25, "The minimum possible value for the ping of the bots")
rb_maxPing         = config.cvar("rb_maxPing",        100, "The maximum possible value for the ping of the bots")
rb_pingUpdateDelay = config.cvar("rb_pingUpdateDelay", 10, "The amount of seconds between each ping update")
rb_botAmount       = config.cvar("rb_botAmount",        4, "Maximum amount of bots to be in the server")
rb_botAutoKick     = config.cvar("rb_botAutoKick",      1, "Whether or not to automatically kick bots when humans join")
rb_botTalk         = config.cvar("rb_botTalk",          1, "Allow bots to reply to certain events? (see bott_speech.ini)")
rb_botOnBotTalk    = config.cvar("rb_botOnBotTalk",     1, "Allow bots talk to trigger other bots say triggers?")

config.text("", False)
config.text("------------------------------------------------------------------------------")
config.text(" WEAPON TEMPLATES")
config.text("    Here define all your weapon templates... These templates will give the")
config.text("    bots a weapon prefernce... e.g. if the bot had a template which contained")
config.text("    \"awp, scout\" then they are more likely to buy those weapons rather than")
config.text("    any other weapons.")
config.text("---")
config.text(" The correct syntax is:")
config.text("   o rb_templateWeapon <name> <weapons>")
config.text("------------------------------------------------------------------------------")
config.command("rb_templateWeapon")

config.text("", False)
config.text("------------------------------------------------------------------------------")
config.text(" SKILL TEAMPLATES")
config.text("    These define how good the bots will behave with certain templates. They")
config.text("    control how good they are (skill), how aggresive they are, their reaction")
config.text("    time and overall difficulty. The difficulty is either \"EXPERT\", \"HARD\",")
config.text("    \"NORMAL\" or \"EASY\". The difficulty means what mode do these bots appear on.")
config.text("    e.g. If bot_diffuculty is set to 0 (easy) and you set the difficulty to HARD, then")
config.text("    the bot will never appear on easy, only when bot_difficulty is set to 2 (hard).")
config.text("---")
config.text(" The correct syntax is:")
config.text("   o rb_templateSkill <name> <skill 0-100> <agression <0-100> <reaction-time> <difficulty>")
config.text("------------------------------------------------------------------------------")
config.command("rb_templateSkill")

config.text("", False)
config.text("------------------------------------------------------------------------------")
config.text(" THE BOTS")
config.text("     Here you create all the possible bots thatwill be on the server. There")
config.text("     must at least be the same amount (or more) than the cvar  rb_botAmount.")
config.text("     This command allows you to assign a skill template, a weapon template,")
config.text("     name, skin and pitch to the bot. The last value is optional (skin)")
config.text("     To get the full features, you must create the same about of bots")
config.text("     with the same difficulty as your bot_difficulty as your rb_botAmount.")
config.text("     For example, if your rb_botAmount is set to 4, and your bot_difficulty")
config.text("     is set to 1 (NORMAL), then you need to create at least 4 bots with a")
config.text("     skill template with a difficulty of NORMAL.")
config.text("---")
config.text(" The correct syntax is:")
config.text("   o rb_create <skill template> <weapon template> <shortname> <longname> [skin (1-4)]")
config.text("------------------------------------------------------------------------------")
config.command("rb_create")

config.write()

####################
### CONSTRUCTORS ###
####################

def load(forced = False):
    """  """    
    if forced:
        addBots = bots.execute()
        if addBots:
            """
            currentDelay = 0.1
            loop         = True
            while bots.botCount < int(rb_botAmount) and loop:
                gamethread.delayedname(currentDelay, 'bot_add', bots.addBot)
                currentDelay += 0.1
                if currentDelay >= (int(rb_botAmount) * 0.1) + 0.1:
                    loop = False
            gamethread.delayed(currentDelay + 0.1, gamethread.cancelDelayed, 'bot_add')
            """
            bots.updatePing()
            gamethread.delayed(1, setBotValue)
        else:
            es.dbgmsg(0, "Changing map to the current one to reset the bots stats....")
            es.server.queuecmd('changelevel %s' % str(es.ServerVar('eventscripts_currentmap') ) )
    else:
        #cmdlib.registerServerCommand('rb_create',         botCommand, "rb_create <skill template> <weapon templayer> <shortname> <longname> [skin]")
        #cmdlib.registerServerCommand('rb_templateSkill',  tempSkill,  "rb_templateSkill <name> <skill 0-100> <agression <0-100> <reaction-time> <difficulty>")
        #cmdlib.registerServerCommand("rb_templateWeapon", tempWeapon, "rb_templateWeapon <name> <weapons>")
        commands = {
            "rb_create": ("botCommand", "rb_create <skill templaye> <weapon template> <shortname> <longname> <skin>"),
            "rb_templateSkill": ("tempSkill", "rb_templateSkill <name> <skill 0-100> <agression 0 - 100> <reaction time> <difficulty>"),
            "rb_templateWeapon" : ("tempWeapon", "rb_templateWeapon <name> <weapons>")
            }
        for command in commands:
            if not es.exists('command', command):
                es.regcmd(command, "realbots/%s"%commands[command][0], commands[command][1])
        config.execute(True)
        gamethread.delayed(0, gamethread.delayed, (0, load, True) )
            
def unload():
    bots.removeAllBots()
    gamethread.cancelDelayed('botPing')
    #cmdlib.unregisterServerCommand('rb_create')
    #cmdlib.unregisterServerCommand('rb_templateSkill')
    #cmdlib.unregisterServerCommand('rb_templateWeapon')
    
##############
### EVENTS ###
##############
        
def es_map_start(event_var):
    #setBotValue()
    bots.updateBotCount()
    if event_var == "forced":
        """
        currentDelay = 0.1
        loop         = True
        while bots.botCount < int(rb_botAmount) and loop:
            gamethread.delayedname(currentDelay, 'bot_add', bots.addBot)
            currentDelay += 0.1
            if currentDelay >= (int(rb_botAmount) * 0.1) + 0.1:
                loop = False
        gamethread.delayed(currentDelay + 0.1, gamethread.cancelDelayed, 'bot_add')
        """
        gamethread.delayed(1, setBotValue)
    else:
        gamethread.delayed(1, load, "forced")
        
"""
def player_activate(event_var):
    if event_var['es_steamid'] != "BOT":
        if bots.botCount and int(rb_botAutoKick):
            count, team = max(map(lambda x: [es.getplayercount(x), x], [2,3] ) )
            botNames = map(lambda x: es.getplayername(x), filter(lambda x: es.isbot(x) and es.getplayerteam(x) == team, es.getUseridList() ) )
            if len(botNames):
                bots.removeBot(random.choice(botNames))
            else:
                bots.removeBot()
"""

def player_disconnect(event_var):
    bots.updateBotCount()
    #if event_var['networkid'] != "BOT" and bots.botCount < int(rb_botAmount):
    #bots.addBot()
    #else:
    gamethread.cancelDelayed('bot_say_%s' % event_var['userid'])
        
def round_start(event_var):
    bots.updateBotCount()
    """
    if bots.botCount > int(rb_botAmount):
        while bots.botCount > int(rb_boutAmount):
            count, team = max(map(lambda x: [es.getplayercount(x), x], [2,3] ) )
            botNames = map(es.getplayername, filter(lambda x: es.isbot(x) and es.getplayerteam(x) == team, es.getUseridList() ) )
            if len(botNames):
                bots.removeBot(random.choice(botNames))
            else:
                bots.removeBot()
    elif 0 < bots.botCount <= int(rb_botAmount):
        humanCount = len( filter( lambda x: not es.isbot(x), es.getUseridList() ) )
        if humanCount + bots.botCount > int(rb_botAmount): 
            #There are bots and humans (I.E not rb_botAmount yet) but in total,
            #there are more than rb_botAmount players, so something stuffed up
            #happened.
            while humanCount + bots.botCount > int(rb_botAmount) and bots.botCount:
                bots.removeBot()
    """
    random_bot = filter(es.isbot, es.getUseridList() )
    if not random_bot:
        return 
    text = checkEvent('roundstart')
    forceSay( random.choice(random_bot), text)
        
def round_end(event_var):
    bots.updateBotCount()
    random_bot = filter(es.isbot, es.getUseridList() )
    if not random_bot:
        return
    random_ct = filter(lambda x: es.getplayerteam(x) == 3, random_bot)
    random_t  = filter(lambda x: es.getplayerteam(x) == 2, random_bot)
    
    if event_var["winner"] == "2":
        if random_ct:
            text = checkEvent('roundlost')
            forceSay(random.choice(random_ct), text)
        if random_t:
            text = checkEvent('roundwon')
            forceSay(random.choice(random_t), text)
    elif event_var["winner"] == "3":
        if random_t:
            text = checkEvent('roundlost')
            forceSay(random.choice(random_t), text)
        if random_ct:
            text = checkEvent('roundwon')
            forceSay(random.choice(random_ct), text)
        
def player_hurt(event_var):
    bots.updateBotCount()
    if event_var['es_userteam'] != event_var['es_attackerteam']:
        text = checkEvent('hurt', {'victim':event_var['es_username'], 'attacker':event_var['es_attackername']})
        forceSay(event_var['userid'], text)
        text = checkEvent('damaged', {'victim':event_var['es_username'], 'attacker' : event_var['es_attackername']})
        forceSay(event_var['attacker'], text)
    else:
        if event_var['userid'] != event_var['attacker']:
            text = checkEvent('teamattacked', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['userid'], text)
            text = checkEvent('teamattacker', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['attacker'], text)
                
def player_death(event_var):
    bots.updateBotCount()
    if event_var['es_userteam'] != event_var['es_attackerteam']:
        if int(event_var['headshot']):
            text = checkEvent('headshot', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['userid'], text)
            text = checkEvent('headshoted', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['attacker'], text)
            return
        if event_var['weapon'] == "knife":
            text = checkEvent('knife', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['userid'], text)
            text = checkEvent('knifed', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['attacker'], text)
            return 
        if event_var['weapon'] == "hegrenade":
            text = checkEvent('grenade', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['userid'], text)
            text = checkEvent('grenaded', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['attacker'], text)
            return
        text = checkEvent('death', {'victim':event_var['es_username'], 'attacker':event_var['es_attackername']})
        forceSay(event_var['userid'], text)
        text = checkEvent('kill', {'victim':event_var['es_username'], 'attacker' : event_var['es_attackername']})
        forceSay(event_var['attacker'], text)
    else:
        if event_var['userid'] != event_var['attacker']:
            text = checkEvent('teamkilled', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['userid'], text)
            text = checkEvent('teamkill', {'victim' : event_var['es_username'], 'attacker' : event_var['es_attackername']})
            forceSay(event_var['attacker'], text)
    
def player_say(event_var):
    bots.updateBotCount()
    if event_var['es_steamid'] != "BOT" or int(rb_botOnBotTalk):
        if "say" in bots.sayEvents:
            if 'percentage' not in bots.sayEvents["say"] or random.randint(1, 100) <= int(bots.sayEvents["say"]['percentage']):
                text_list = filter(lambda x: x != "percentage", bots.sayEvents["say"])
                for text in text_list:
                    if event_var['text'].lower().strip() == text.strip():
                        random_bot = filter(lambda x: es.isbot(x) and x != int(event_var['userid']), es.getUseridList() )
                        if not random_bot:
                            return
                        forceSay(random.choice(random_bot), random.choice(map(lambda x: x.strip(), bots.sayEvents["say"][text].split(','))))
                        break

#################
### FUNCTIONS ###
#################
    
def botCommand(args = None):
    """ rb_create <skill template> <weapon templayer> <shortname> <longname> [skin] """
    if args is None:
        args = filter(bool, [es.getargv(x) for x in range(1, 6)])
    if len(args) not in (4, 5):
        raise ValueError, "Unsupported number of args for rb_create: %s" % ( " ".join(args) )
    skillTemplate  = args[0]
    weaponTemplate = args[1]
    shortName      = args[2]
    longName       = args[3]
    skin           = args[4] if len(args) == 5 else 4 
    bots.createBot(skillTemplate, weaponTemplate, shortName, longName, skin)
    
def tempSkill(args = None):
    """ rb_templateSkill <name> <skill 0-100> <agression <0-100> <reaction-time> <difficulty> [pitch] """
    if args is None:
        args = filter(bool, [es.getargv(x) for x in range(1, 7)])
    if len(args) not in (5, 6):
        raise ValueError, "Unkown number of attributes for rb_templateSkill: %s" % ( " ".join(args) )
    name       = args[0]
    skill      = int(args[1])
    agression  = int(args[2])
    reactTime  = float(args[3])
    difficulty = args[4].upper()
    pitch      = int(args[5]) if len(args) == 6 else 90
    bots.createTemplate("skill", name, skill, agression, reactTime, difficulty, pitch)
    
def tempWeapon(args = None):
    """ rb_templateWeapon <name> <weapons> """
    if args is None:
        args = filter(bool, [es.getargv(x) for x in range(1, 3)])
    if len(args) != 2:
        raise ValueError, "Unsupported number of args for rb_templayerWeapon: %s" % ( " ".join(args) )
    name    = args[0]
    weapons = map(lambda x: x.strip(), args[1].split(',') )
    bots.createTemplate("weapon", name, weaponPreference=weapons )
    
def forceSay(userid, text):
    if es.isbot(userid):
        if text:
            gamethread.cancelDelayed('bot_say_%s'%userid)
            if text.endswith('|team'):
                # Make the text delay so it seems like the bot is actually taking time to type (between 5-7 letters per second)
                text = text.replace('|team','')
                gamethread.delayedname(random.randint(len(text)/7,len(text)/5) + 1, 'bot_say_%s' % userid, es.sexec, (userid, 'say_team', text) )
            else:
                # Make the text delay so it seems like the bot is actually taking time to type (between 5-7 letters per second)
                gamethread.delayedname(random.randint(len(text)/7,len(text)/5) + 1, 'bot_say_%s' % userid, es.sexec, (userid, 'say', text) )
        
def checkEvent(eventName, tokens={}):
    if eventName in bots.sayEvents and int(rb_botTalk):
        random_number = random.randint(1,100)
        if random_number <= int(bots.sayEvents[eventName]['percentage']):
            return Template(bots.sayEvents[eventName][random.choice(filter(lambda x: x != "percentage", bots.sayEvents[eventName]))]).substitute(tokens)
    return None
"""
def addInitialBots():
    while bots.botCount < int(rb_botAmount):
        bots.addBot()
"""

def setBotValue():
    #es.server.queuecmd('bot_profile_db "botprofile.db"')
    es.server.queuecmd('bot_prefix ""')
    es.server.queuecmd('bot_join_after_player 0')
    es.server.queuecmd('bot_defer_to_human 0')
    es.server.queuecmd('bot_chatter "off"')
    es.server.queuecmd('bot_auto_vacate %s'%rb_botAutoKick)
    es.server.queuecmd('bot_allow_rogues 1')
    es.server.queuecmd('bot_quota %s'%rb_botAmount)
    es.server.queuecmd('bot_quota_mode %s' % ('normal' if not rb_botAutoKick else 'fixed') )